Subject: Re: [PATCH 2/2]: [NET_SCHED]: Making rate table lookups more flexible.

From: Patrick McHardy <[email-masked]>
Date: Tue, 04 Sep 2007 18:25:29 +0200

Jesper Dangaard Brouer wrote:
> On Sun, 2007-09-02 at 23:16 +0200, Patrick McHardy wrote:
> 
>>Jesper Dangaard Brouer wrote:
>>
>>>On Sun, 2 Sep 2007, Patrick McHardy wrote:
>>>
>>>Lets focus on the general case, where the functionality actually is 
>>>needed right away.
>>>
>>>In the general case:
>>>
>>>- The rate table needs to be aligned (cell_align=-1).
>>>  (currently, we miscalculates up to 7 bytes on every lookup)
>>
>>We will always do that, thats a consequence of storing the
>>transmission times for multiples of 8b.
> 
> 
> The issue is that we use the lower boundary for calculating the transmit
> cost. Thus, a 15 bytes packet only have a transmit cost of 8 bytes.

I believe this is something that should be fixed anyway,
its better to overestimate than underestimate to stay
in control of the queue. We could additionally make the
rate tables more finegrained (optionally).

>>>- The existing tc overhead calc can be made more accurate.
>>>  (by adding overhead before doing the lookup, instead of the
>>>   current solution where the rate table is modified with its
>>>   limited resolution)
>>
>>Please demonstrate this with patches (one for the overhead
>>calculation, one for the cell_align thing), then we can
>>continue this discussion.
> 
> 
> I have attached a patch for the overhead calculation.

Thanks, I probably won't get to looking into this until
after the netfilter workshop next week.